////////////////////////////////////////////////////////////////
// RSSP ResizeSprite

#include <ctype.h>

short Hash(char *str) {
	short r;

	r = 0;
	while (*str) {
		r = (r << 1) | ((r >> 15) & 1);
		r ^= (unsigned short)(*(str++));
	}

	return r;
}

char *str2val(char *str, int *n) {
	short minus = 0;
	int v = 0;

	while (isspace(*str)) str++;

	if (*str == '-') {
		minus = 1;
		str++;
	}

	if (isdigit(*str)) {
		if ((*str == '0') && ((*(str+1) == 'X') || (*(str+1) == 'x'))) {
			while (isxdigit(*str)) {
				if (islower(*str)) {
					v = v*16 + *str - 'a'+10;
				} else if (isupper(*str)) {
					v = v*16 + *str - 'A'+10;
				} else {
					v = v*16 + *str - '0';
				}
			}
		} else {
			while (isdigit(*str)) v = v*10 + *str - '0';
		}
	}

	if (minus) v = -v;

	*n = v;
	return str;
}

int strequ(char *str1, char *str2) {
	if (str1 == str2) return 1;

	for (;;) {
		char c1 = *(str1++);
		char c2 = *(str2++);
		if (c1 != c2) return 0;
		if (c1 == '\0') return 1;
	}
}

int striequ(char *str1, char *str2) {
	if (str1 == str2) return 1;

	for (;;) {
		char c1 = toupper(*(str1++));
		char c2 = toupper(*(str2++));
		if (c1 != c2) return 0;
		if (c1 == '\0') return 1;
	}
}

char *strcutcr(char *str) {
	char *r = str;

	while (*str) str++;
	str--;

	while ((*str == 0x0d) || (*str == 0x0a)) str--;
	*str = '\0';

	return r;
}

